
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>C#编写第三方控件，实现窗体控件的一键赋值 / 憋错料</title>

    <meta name="description" content="C#编写第三方控件，实现窗体控件的一键赋值 . 事出有因 在写程序的时候,经常会写上面这样的代码,把查询的结果显示到窗体上,我们怎么做的呢? 一行一行的进行赋值,这样的代码写起来最枯燥,而且还容易出错.大家有没有发现,上面的代码都在做相同的事情-赋值.相类似的代码写了三遍以上,就要考虑是不是能对这个过程进行封装.封装出一个方法,帮我们自动完成这些重复性的操作. 思考过程 所接触项目中也有写好的类似方法.只是它涉及到了很多其它的方法,一个套一个,抽离出来特别不方便.而且还有几个令人不爽的地方: 第一是,控件在命名的时候必须和相对应实体属性相">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">C#编写第三方控件，实现窗体控件的一键赋值</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDA5MDkyMjMyMTk3Mzg/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2ZFRBeE1EQXlPRGcyT1E9PS9mb250LzVhNkw1TDJUL2ZvbnRzaXplLzQwMC9maWxsL0kwSkJRa0ZDTUE9PS9kaXNzb2x2ZS83MC9ncmF2aXR5L1NvdXRoRWFzdA==.jpg">、</p>
<p>事出有因</p>
<p>在写程序的时候，经常会写上面这样的代码，把查询的结果显示到窗体上，我们怎么做的呢？ 一行一行的进行赋&#20540;，这样的代码写起来最枯燥，而且还容易出错。大家有没有发现，上面的代码都在做相同的事情—赋&#20540;。相类&#20284;的代码写了三遍以上，就要考虑是不是能对这个过程进行封装。封装出一个方法，帮我们自动完成这些重复性的操作。</p>
<p>思考过程</p>
<p>所接触项目中也有写好的类&#20284;方法。只是它涉及到了很多其它的方法，一个套一个，抽离出来特别不方便。而且还有几个令人不爽的地方： 第一是，控件在命名的时候必须和相对应实体属性相同。比如说，姓名这一项，实体的属性名称为sname,那么控件的名称也必须是sname,显然这和我们所遵循的一般命名规范是相违背的。第二是，控件的可见性级别必须设置为Public ,要不然会赋不上&#20540;。</p>
<p>所以，在研究完他的方法后，对它重新进行了编写，做出了一些改进。弥补了上面的两个缺点，使其应用起来更加方便一些。</p>
<p>所用到的方法，题目中写提到了。编写第三方控件，听着挺高大上，其实就是对C#原有的控件,进行重写，增加一条自己用到的属性而已。在这里增加的属性我将它命名为DataField，用来保存数据库字段的名称。作用嘛？往下看就知道了。。</p>
<p>笔者在这用C#编写了一个Demo，用来说明如何编写第三方控件以及窗体的一键赋&#20540;。</p>
<p>具体实现过程</p>
<p>新建一个C#项目</p>
<p>添加一个接口 Interface1：</p>
<pre>&lt;span style=&quot;font-size:18px;&quot;&gt;    interface Interface1
    {       //定义DataField属性
        string DataField { get; set; }

    }&lt;/span&gt;</pre>
<p>添加两个类ComboxEx、ComboxEx：</p>
<pre>using System.Windows.Forms;  //添加引用

    internal class TextBoxEx : TextBox, Interface1
    {       //该类继承TextBox控件和接口Interface1
        #region Interface1 成员

        public string DataField
        { get; set; }

        #endregion
    }
    internal class ComboxEx : ComboBox, Interface1
    {
        #region Interface1 成员

        public string DataField
        { get; set; }

        #endregion
    }
</pre>
<p>然后打开工具箱，我们会看到：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDA5MDkyMjM3NDEyNzA/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2ZFRBeE1EQXlPRGcyT1E9PS9mb250LzVhNkw1TDJUL2ZvbnRzaXplLzQwMC9maWxsL0kwSkJRa0ZDTUE9PS9kaXNzb2x2ZS83MC9ncmF2aXR5L1NvdXRoRWFzdA==.jpg"></p>
<p>这就是我们封装的第三方控件。把它拖到窗体上，右击查看其属性</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDA5MDkyMjM5MjY3MjY/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2ZFRBeE1EQXlPRGcyT1E9PS9mb250LzVhNkw1TDJUL2ZvbnRzaXplLzQwMC9maWxsL0kwSkJRa0ZDTUE9PS9kaXNzb2x2ZS83MC9ncmF2aXR5L1NvdXRoRWFzdA==.jpg"></p>
<p>它多了一条DataField属性，我们可以给他赋上&#20540;SID（学生表的字段名—学号）同样再拖拽出几个控件并且赋&#20540;。</p>
<p>如图：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDA5MDkyMjQwNDU1ODQ/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2ZFRBeE1EQXlPRGcyT1E9PS9mb250LzVhNkw1TDJUL2ZvbnRzaXplLzQwMC9maWxsL0kwSkJRa0ZDTUE9PS9kaXNzb2x2ZS83MC9ncmF2aXR5L1NvdXRoRWFzdA==.jpg"></p>
<p>然后开始正式编写代码，添加一个实体类StuEntity：</p>
<p>注意：实体属性的名称要和数据库字段名称保持一致！</p>
<pre>    public class StuEntity
    {
        /// &lt;summary&gt;
        /// 学号
        /// &lt;/summary&gt;
        public string SID { get; set; }
        /// &lt;summary&gt;
        /// 姓名
        /// &lt;/summary&gt;
        public string sname { get; set; }
        /// &lt;summary&gt;
        /// 性别
        /// &lt;/summary&gt;
        public string sex { get; set; }
        /// &lt;summary&gt;
        /// 系别
        /// &lt;/summary&gt;
        public string department { get; set; }
        /// &lt;summary&gt;
        /// 年级
        /// &lt;/summary&gt;
        public string grade { get; set; }
        /// &lt;summary&gt;
        /// 班级
        /// &lt;/summary&gt;
        public string sclass { get; set; }
    }
</pre>
<p>需要说明的一点：这只是一个小Demo并没有采用分层的写法，把编写的方法全部放在了FrmHelper类中</p>
<pre>    public class FrmHelper
    {
        /// &lt;summary&gt;
        /// 获取实体，将DataTable的行赋值给实体类enStudent
        /// 这里可以采用机房中封装好的方法，将DataTable转换
        /// 成实体类的泛型集合，可以省去这些赋值。
        /// &lt;/summary&gt;
        /// &lt;param name=&quot;dr&quot;&gt;DataTable的行&lt;/param&gt;
        /// &lt;returns&gt;返回实体类enStudent&lt;/returns&gt;
        public static StuEntity GetEntity(DataRow dr)
        {
            StuEntity enStudent = new StuEntity();
            enStudent.SID = dr[&quot;SID&quot;].ToString();
            enStudent.sname = dr[&quot;sname&quot;].ToString();
            enStudent.sex = dr[&quot;sex&quot;].ToString();
            enStudent.department = dr[&quot;department&quot;].ToString();
            enStudent.grade = dr[&quot;grade&quot;].ToString();
            enStudent.sclass = dr[&quot;sclass&quot;].ToString();
            return enStudent;
        }

        /// &lt;summary&gt;
        /// 将实体类中属性的值，填充到窗体的控件上
        /// &lt;/summary&gt;
        /// &lt;param name=&quot;enStudent&quot;&gt;&lt;/param&gt;
        public static void FillFormByEntity(StuEntity enStudent, Form thisfrm)
        {
            //遍历窗体上的控件
            foreach (Control ctrl in thisfrm.Controls)
            {
                //是否继承了接口
                if (ctrl is Interface1)
                {
                    //是否属于文本框
                    if (ctrl is TextBoxEx)
                    {
                        ctrl.Text = GetValue(enStudent, ((TextBoxEx)ctrl).DataField);
                    }//如果属于下拉框
                    else if (ctrl is ComboxEx)
                    {
                        ((ComboxEx)ctrl).Text = GetValue(enStudent, ((ComboxEx)ctrl).DataField);
                    }
                    //如果还有其他类型的控件，可在此进行扩展。
                }
            }
        }
        /// &lt;summary&gt;
        /// 利用反射技术，动态的从实体中获取与控件相对应的值
        /// &lt;/summary&gt;
        /// &lt;param name=&quot;enStudent&quot;&gt;实体类&lt;/param&gt;
        /// &lt;param name=&quot;DataFiled&quot;&gt;字段值&lt;/param&gt;
        /// &lt;returns&gt;&lt;/returns&gt;
        public static string GetValue(StuEntity enStudent, string DataFiled)
        {
            PropertyInfo field = enStudent.GetType().GetProperty(DataFiled);
            return field.GetValue(enStudent, null).ToString();
        }

        /// &lt;summary&gt;
        /// 执行查询语句，返回一个DateTable
        /// &lt;/summary&gt;
        /// &lt;returns&gt;DateTable&lt;/returns&gt;
        public static DataTable QueryTable()
        {
            using (SqlConnection connection = new SqlConnection(&quot;server=.; database=Re_Charge_sys;user id=sa;password=123456&quot;))
            {
                SqlCommand cmd = connection.CreateCommand();
                cmd.CommandText = @&quot;select * from Student_info where SID =&#039;110&#039;&quot;;
                DataTable dt = new DataTable();
                DataSet ds = new DataSet();
                try
                {
                    connection.Open();
                    SqlDataAdapter sqlAdapter = new SqlDataAdapter(cmd);
                    sqlAdapter.Fill(ds);
                    dt = ds.Tables[0];
                }
                catch (System.Data.SqlClient.SqlException ex)
                {
                    throw new Exception(ex.Message);
                }
                return dt;
            }
        }
    }
</pre>
<p>客户端调用：</p>
<pre>        private void btnFillValue_Click(object sender, EventArgs e)
        {
            DataTable dt = FrmHelper.QueryTable();
            StuEntity enStudent = FrmHelper.GetEntity(dt.Rows[0]);
            FrmHelper.FillFormByEntity(enStudent, this);
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            cmbGrade.Items.AddRange(new String[] { &quot;一年级&quot;, &quot;二年级&quot;, &quot;三年级&quot;, &quot;四年级&quot; });
            cmbSex.Items.AddRange(new String[] { &quot;男&quot;, &quot;女&quot; });

            //cmbSex.Items.Add(new KeyValuePair&lt;string, string&gt;(&quot;男&quot;, &quot;男&quot;));
            //cmbSex.Items.Add(new KeyValuePair&lt;string, string&gt;(&quot;女&quot;, &quot;女&quot;));
            //cmbSex.DisplayMember = &quot;Key&quot;;
            //cmbSex.ValueMember = &quot;Value&quot;;
        }
</pre>
<p>点击赋&#20540;按钮，从数据库读取出的数据就会自动填写到界面控件当中。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDA5MDkyMjQ0MDAwMzk/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2ZFRBeE1EQXlPRGcyT1E9PS9mb250LzVhNkw1TDJUL2ZvbnRzaXplLzQwMC9maWxsL0kwSkJRa0ZDTUE9PS9kaXNzb2x2ZS83MC9ncmF2aXR5L1NvdXRoRWFzdA==.jpg"></p>
<p>谈谈第三方控件</p>
<p>当然通过这种方法也能增加其他的属性，比如NotEmpty ，把判断是否为空的方法写在接口里，然后让控件去继承。通过设置该属性的&#20540;为 True / False 决定控件内容是否可为空。通过这种方式就避免再去写方法去一个个判断，省时省力。说到这里我不得不感叹一下了：站在巨人的肩膀上。 其实现在互联网上已经有很多已经封装好的，强大的第三方控件。比如说现在所用的C1Studio，对常用控件进行了封装，增加很多特别方便实用的属性，</p>
<p>不得不说第三方控件现在挺吃香的，因为他给原来死的控件增加了生命力和色彩。</p>
<p>写在最后：</p>
<p>做程序员或者说做人，不能太实在、按部就班。</p>
<p>要多思考，多去寻找能“偷懒”的方法。</p>
<p>时刻想着，站在巨人的肩膀上。</p>
<p>给窗体控件赋&#20540;就写到这里，当然有赋&#20540;就有取&#20540;，将控件的&#20540;赋给实体，传到数据访问层再进行操作。也是MIS系统中经常用到的。方法和赋&#20540;类&#20284;，具体代码将在下篇博客中呈现给大家。</p>
<p>oノo════════════════════════════╲</p>
<p>│ヽ.学无止境， 分享至上。&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; │</p>
<p>│&nbsp;&nbsp; 出自：&nbsp; <a href="http://blog.csdn.net/u010028869" rel="external nofollow noreferrer">http://blog.csdn.net/u010028869</a>&nbsp;&nbsp;&nbsp;&nbsp; .ヽ│</p>
<p>╲═════════════════════════════ヾ</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-20 11:40:57 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/%e6%8e%a7%e4%bb%b6/" title="控件">控件</a>, <a href="https://www.biecuoliao.com/tag/%e7%ac%ac%e4%b8%89%e6%96%b9%e6%8e%a7%e4%bb%b6/" title="第三方控件">第三方控件</a>, <a href="https://www.biecuoliao.com/tag/%e7%95%8c%e9%9d%a2%e8%b5%8b%e5%80%bc/" title="界面赋值">界面赋值</a>, <a href="https://www.biecuoliao.com/tag/%e7%aa%97%e4%bd%93%e6%8e%a7%e4%bb%b6%e7%9a%84%e8%b5%8b%e5%80%bc/" title="窗体控件的赋值">窗体控件的赋值</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>C#编写第三方控件，实现窗体控件的一键赋值的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0Ygn5y4.html" rel="bookmark">C&num;编写第三方控件，实现窗体控件的一键取值</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				上篇博客中讲到了利用编写第三方控件的方法,实现给窗体控件的Text属性赋值,比如说:TextBox,Combox等.有赋值,当然也有取值操作.从窗体的控件中取值,然后存入变量或者实体属性当中,传入到数据访问层进行添加,更新等操作也是我们经常使用的.如何实现一键取值呢? 使用的方法在上篇博客中已经做了详细说明,这里就不再累述了. 代码写在这里: 该方法的作用是,遍历传入窗体中的控件,并且获取其值赋给实体类的相应属性. /// &lt;summary&gt; /// 从窗体控件取值,填充到学生实体类中 ///			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MgR2NK4.html" rel="bookmark">C&num;窗体控件简介ListBox</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				ListBox 控件ListBox 控件又称列表框,它显示一个项目列表供用户选择.在列表框中,用户一次可以选择一项,也可以选择多项.1.常用属性:(1) Items属性: 用于存放列表框中的列表项,是一个集合.通过该属性,可以添加列表项.移除列表项和获得列表项的数目.(2)MultiColumn 属性:用来获取或设置一个值,该值指示ListBox是否支持多列.值为 true 时表示支持多列,值为 false 时不支持多列.当使用多列模式时,可以使控件得以显示更多可见项.(3)ColumnWidt			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MoooDDM.html" rel="bookmark">窗体控件应用总结（1）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.如果想要通过点击菜单控件或工具栏控件达到是窗体变大变小的功能首先双击控件进入代码编写 绑定事件 this.Size = new Size(600, 400);//(int x,int y)设定窗体大小 2.想要使状态栏呈现当前窗体是大还是小 sta1.Text = &quot;大窗体&quot;;//状态栏name.Text=&quot;......&quot;:写在与菜单控件或工具控件的事件中 3.如果想要设定当前窗体的背景颜色 this.BackColor = Color.Red; 如果想让状态栏			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MWlzbm0.html" rel="bookmark">如何实现控件随窗体大小的改变而自动适应其改变</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在设计可供用户调整大小的窗体时,如何实现该窗体上的控件也应能正确地随窗体的改变而自动调整大小并且能重新定位?此时就要借助控件的．Anchor属性.Anchor属性定义控件的定位点位置.当控件锚定到某个窗体时,如果该窗体的大小被调整,那么该控件维持它与定位点位置之间的距离不变.例如,如果&quot;:Button&quot;控件锚定到窗体的左.右和底边缘,那么当调整该窗体的大小时,Button控件水平调整大小,维持到该窗体左边和右边的距离不变,另外控件垂直定位其自身,以便其到窗体底边的距离始终不变,如果控件			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MoNGPl4.html" rel="bookmark">Qt编写自定义控件23-广告轮播控件</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.前言 广告轮播这个控件做的比较早,是很早以前定制一个电信客户端时候用到的,该客户端需要在首页展示轮播预先设定好的图片,图片的路径可以自由设定,然后轮播的间隔速度可以自由控制,同时该控件还需要提供两种指示器的风格,一种是迷你型的样式,一种是数字型的样式. 本控件很早就做好了,由于当时的QPainter功力不足,还不是很熟悉QPainter,采用的是效率比较低的直接用现有控件堆积而成,比如指示器采用的QLabel,用样式表来控制对应的形状,指示器所在的底部放一个widget,采用左右布局,然后右			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/49Qrev4.html" rel="bookmark">Qt编写自定义控件24-图片轮播控件</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.前言 上一篇文章写的广告轮播控件,采用的传统widget堆积设置样式表做的,这次必须要用到更高级的QPainter来绘制了,这个才是最高效的办法,本控件参考雨田哥的轮播控件,经过大规模的改造而成,相比于原来的广告轮播控件,本控件可以说完爆他,按在地上使劲摩擦.除了可以设置图片路径集合以外,还可以设置对应的提示信息,这个在众多的web轮播图片效果中最常见,比如新闻的标题等,可以更直观的显示当前图片,而且单击图片还可以支持跳转,指示器的位置也能设置左边+中间+右边,指示器的样式更加增加到椭圆条状			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4JDKdP0.html" rel="bookmark">用于列出选项的Windows窗体控件</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				可以提供选项列表的控件有ListBox.ComboBox.CheckedListBox,如何正确的使用和选择这些控件,下面对此进行讨论.首先对这三种控件的功能分别进行说明: ListBox ListBox用于显示项列表,用户可以从中选择一项或多项.如果项目总数超出可以显式的项目数,则ListBox会自动添加滚动条.当MultiColumn属性为true时,列表框以多列形式显示条目,并且会出现一个水平滚动条.当MultiColumn为false时,列表框以单列形式显示条目,并且会出现一个垂直滚动条			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0dgLQgM.html" rel="bookmark">如何跨线程调用Windows窗体控件</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				通过一个子线程来操作主线程中的控件,但是,这样作会出现一个问题(如图1所示),就是TextBox控件是在主线程中创建的,在子线程中并没有对其进行创建,也就是从不是创建控件的线程访问它.那么,如何解决跨线程调用Windows窗体控件呢?可以用线程委托实现跨线程调用Windows窗体控件.下面将上一个例子进行一下改动.代码如下: using System; using System.Collections.Generic; using System.ComponentModel; using Sys			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0lrgRB4.html" rel="bookmark">C&num;窗体控件拖动</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				using System;using System.Collections.Generic;using System.ComponentModel;using System.Data;using System.Drawing;using System.Linq;using System.Text;using System.Threading.Tasks;using System.Windows.Forms; namespace 窗体控件移动{public partial class Form1			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/yMXYZX0.html" rel="bookmark" class="title">sql优化（oracle）- 第三部分 &amp;&num;160&semi;sql优化总结</a>
					<div>
						第三部分  sql优化总结        1. 优化一般原则        2. 具体注意事项 1. SQL优化一般性原则 1)目标:减少服务器资源消耗(主要是磁盘IO) 2)设计: 1. 尽量依赖o ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Z0YQda0.html" rel="bookmark" class="title">asp&period;ne中使用ajax和controller进行通信问题记录</a>
					<div>
						为了页面显示和后端处理分离,使用了html+ajax+mvc的形式进行处理. 在这其中遇到的问题记录: 1. 在使用ajax向controller请求数据的时候,&quot;get&quot;方法会缓 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/pMPnlz3.html" rel="bookmark" class="title">Java：日期类Date与Calendar</a>
					<div>
						怎么获取系统系统时间,通过java? Date now= new Date(); SimpleDateFormat dateFormat=new SimpleDateFormat(&quot;yyyy ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YGDjv4.html" rel="bookmark" class="title">（数组）Largest Rectangle in Histogram（栈解问题）</a>
					<div>
						Largest Rectangle in Histogram Given n non-negative integers representing the histogram's bar height ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDZDen3.html" rel="bookmark" class="title">数据类型【js】</a>
					<div>
						javascript的数据类型: Number String Boolean undefined  共4种. 类型的总结: 所有的数值都是number类型 字符和字符串都是string类型 布尔是bo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MgXDo80.html" rel="bookmark" class="title">【转】成为Java顶尖程序员 ，看这11本书就够了</a>
					<div>
						成为Java顶尖程序员 ,看这11本书就够了 转自:http://developer.51cto.com/art/201512/503095.htm 以下是我推荐给Java开发者们的一些值得一看的好书 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qoLNPM.html" rel="bookmark" class="title">JSP数据交互（二）和Servlet基础</a>
					<div>
						01.Application原理与应用 01.application对象的作用域范围是整个应用服务,而它在应用中所承担的责任就类似于一个全局变量.只要服务启动,则application对象就会存在.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4Q8w6k3.html" rel="bookmark" class="title">leetcode 49&period; Anagrams</a>
					<div>
						Given an array of strings, return all groups of strings that are anagrams. Note: All inputs will be  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0K2ZZjM.html" rel="bookmark" class="title">课堂练习之每天出30道四则运算题目</a>
					<div>
						1 /* 2 需求:每天出30道四则运算题目给小学生做 3 */ 4 5 class Rand 6 { 7 public static void sop(Object obj) 8 { 9 Syste ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4Amx1a4.html" rel="bookmark" class="title">Ubuntu下不重装系统安装SSD总结</a>
					<div>
						一．要想给自己的机子装个固态,但又不想重装系统,各种配置,那么就要先把自己的系统从HDD复制到SSD上,这里说下我的情况．我的HDD 是500G ubuntu系统,安装的时候没有分区,默认是dev/s ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M617L54.html" rel="bookmark" class="title">工资高的互联网工作者都在干什么</a>
					<div>
						我来给一个高薪的定义吧:税后到手收入大于年龄,包含年终奖.股票等假如你30岁'到手要有30万'即税前45万以上'才可称为高薪.按同样工龄算,收入达到这样级别的估计在IT圈子都能排前5%,但是不代表这些 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MyKlAe3.html" rel="bookmark" class="title">使用CSS3制作导航条和毛玻璃效果</a>
					<div>
						导航条对于每一个Web前端攻城狮来说并不陌生,但是毛玻璃可能会相对陌生一些.简单的说,毛玻璃其实就是让图片或者背景使用相应的方法进行模糊处理.这种效果对用户来说是十分具有视觉冲击力的. 本次分享的主题 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02LGqA4.html" rel="bookmark" class="title">UESTC&lowbar;秋实大哥打游戏 2015 UESTC Training for Data Structures&amp;lt&semi;Problem H&amp;gt&semi;</a>
					<div>
						H - 秋实大哥打游戏 Time Limit: 3000/1000MS (Java/Others)     Memory Limit: 65535/65535KB (Java/Others) Subm ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41BwjYM.html" rel="bookmark" class="title">预装win8系统用U盘改装win7</a>
					<div>
						联想ThinkPad T440预装win8用U盘引导改装win7 0.开机按enter键,然后选择F1进入BIOS 1.修改security中secure boot选项中secure boot为Dis ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pQvJwM.html" rel="bookmark" class="title">Phoenix Salted Table</a>
					<div>
						1. 概念 Phoenix Salted Table是phoenix为了防止hbase表rowkey设计为自增序列而引发热点region读和热点region写而采取的一种表设计手段.通过在创建表的时候 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGdKxo0.html" rel="bookmark" class="title">js参数顺序不固定的写法</a>
					<div>
						//代码如下function doSomeThing(obj){ var adapter = { name:'name', id:'001', color:'yellow', height:'100' ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGDrny0.html" rel="bookmark" class="title">AC日记&mdash;&mdash;逆波兰表达式 openjudge 3&period;3 1696</a>
					<div>
						1696:逆波兰表达式 总时间限制:  1000ms 内存限制:  65536kB 描述 逆波兰表达式是一种把运算符前置的算术表达式,例如普通的表达式2 + 3的逆波兰表示法为+ 2 3.逆波兰表达式 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/35NZRn4.html" rel="bookmark" class="title">awk深入浅出</a>
					<div>
						文本处理三剑客:grep sed awk grep,egrep,fgrep:文本过滤工具: sed:行编辑器 模式空间.保持空间 awk:报表生成器,用于格式化文本输出工具: 基本用法: awk命令软 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4JjmAA4.html" rel="bookmark" class="title">利用awk处理学生分数排名问题案例</a>
					<div>
						利用awk处理学生分数排名问题真实案例如下: 1.已知老男孩教育运维班26期期中集群架构上台述职报告人员的分数为: 提示:由述职学员上台演讲搭建的集群架构,由学生评委和导师评分,历经2天共产生如下评分 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ZaJll0.html" rel="bookmark" class="title">【转载】【selenium&plus;Python  WebDriver】之元素定位</a>
					<div>
						总结: 感谢&quot;煜妃&quot;&lt;Selenuim+Python之元素定位总结及实例说明&gt;和&quot;Huilaojia123&quot;&lt;selenium WebDriv ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.044 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
